//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;

	using System.Data; // needed for DataTables, DataSets...
	using System.Data.OleDb; // for OleDB 
	
    public partial class Access
    {
		DataTable dt = new DataTable();
		OleDbConnection conn = new OleDbConnection();
		
// Screen Area #####################################################################

		void Access_Opened(System.Object sender, System.EventArgs e)
		{
			MSAccess_DB_Read();
			Globals.Tags.Rows_Deleted.Value = 0;
		}


// Methods Area #####################################################################

		// establish connection to the database
		private OleDbConnection Connect2Access ()
		{
			string m_ConnectionsString =  "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Globals.Tags.MSAccess_DataSource.Value;
			try 
			{	        
				conn.ConnectionString = m_ConnectionsString;
				conn.Open();
				return conn;
			}
			catch (Exception ex)
			{
				conn.Close();
				MessageBox.Show(ex.Message, "Alert");
				return null;
			}
		}
		
		
		// READ MS Access database into DataTable dt and display it in DataGridView1
		private void MSAccess_DB_Read()
		{
			conn = Connect2Access();
			try
			{
				string Commandstring = "SELECT * FROM DATA";
				OleDbCommand cmd = new OleDbCommand(Commandstring, conn);
				OleDbDataAdapter da = new OleDbDataAdapter(cmd);
			
				dt.Rows.Clear();
				dt.Columns.Clear();
				da.Fill(dt);
				DataGridView1.DataSource = dt;
				DataGridView1.AutoResizeColumns();
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
				return;
			}
			finally
			{
				conn.Close();
			}	
        
			// The next several lines show how to get information on a specific table by name from the dataset:
			TextBox1.Text = dt.Rows.Count.ToString();
			// The column info is automatically fetched from the database, so we can read it here:
			TextBox2.Text = dt.Columns.Count.ToString();
			DataColumnCollection drc = dt.Columns;
			
			ListBox1.Items.Clear();
			int i = 0;
			foreach (DataColumn dc in drc)
			{
				// Print the column subscript, then the column's name and its data type:
				ListBox1.Items.Add(string.Format("Column name[{0}] is {1}, of type {2}",i++ , dc.ColumnName, dc.DataType));
			}	
		}
		

// Buttons Area #####################################################################						

		// INSERT the actual prozess data into the MS Access database 
		void Btn_DB_Write_Click(System.Object sender, System.EventArgs e)
		{
			conn = Connect2Access();
			try
			{
				// insert actual process data
				string Commandstring = "INSERT INTO DATA (DB_Time,Voltage,Temperature,Pressure,Comment)" + 
					String.Format("VALUES('{0}',{1},{2},{3},'{4}')",  
					Globals.Tags.DateTime.Value,
					Globals.Tags.Voltage.Value,
					Globals.Tags.Temperature.Value,
					Globals.Tags.Pressure.Value,
					Globals.Tags.Comment.Value
					);
				
				OleDbCommand cmd = new OleDbCommand(Commandstring, conn );
				cmd.ExecuteNonQuery();
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
				return;
			}
			finally
			{
				conn.Close();
			}	
			MSAccess_DB_Read();
		}
		
		
		// DELETE data sets drom the database depending on the SQL command
		void Btn_Record_DEL_Click(System.Object sender, System.EventArgs e)
		{
			conn = Connect2Access();
			try
			{
				string Commandstring = "DELETE FROM DATA WHERE " + Globals.Tags.DEL_String.Value;
				OleDbCommand cmd = new OleDbCommand(Commandstring, conn );
				Globals.Tags.Rows_Deleted.Value = cmd.ExecuteNonQuery();
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
				return;
			}
			finally
			{
				conn.Close();
			}	
        	MSAccess_DB_Read();
		}
		
		
		// write the changes to the database
		void Btn_Update_DB_Click(System.Object sender, System.EventArgs e)
		{
 			conn = Connect2Access();
			try
			{
				string Commandstring = "SELECT * FROM DATA";
				OleDbCommand cmd = new OleDbCommand(Commandstring, conn);
				OleDbDataAdapter da = new OleDbDataAdapter(cmd);
				// the CommandBuilder is needed to have "the easy Update possibility" using "DataAdapter.Update"
				OleDbCommandBuilder cb = new OleDbCommandBuilder(da);
				da.Update(dt);
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
				return;
			}
			finally
			{
				conn.Close();
			}		
		}
		
		
		// select another MS Access database
		void Btn_DB_Input_Click(System.Object sender, System.EventArgs e)
		{
			try 
			{	        
				OpenFileDialog dlgOpen = new OpenFileDialog();
				dlgOpen.InitialDirectory = @"C:\";
				dlgOpen.Filter = "MS Access database (*.mdb)|*.mdb";
				dlgOpen.Title = "Choose Database";
				dlgOpen.ShowDialog();		
				if (! (dlgOpen.FileName == string.Empty) )
				{
					Globals.Tags.MSAccess_DataSource.Value = dlgOpen.FileName;
					MSAccess_DB_Read();
				}
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "Alert");
			}
		}
    }
}
