//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;

	using System.Data; // needed for DataTables, DataSets...
	using MySql.Data.MySqlClient; // for MySQL
	
    public partial class MySQL
    {
		DataTable dt = new DataTable();
		MySqlConnection conn = new MySqlConnection();
		
// Screen Area #####################################################################
		
		void MySQL_Opened(System.Object sender, System.EventArgs e)
		{
			MySQL_DB_Read();
			Globals.Tags.Rows_Deleted.Value = 0;
			Globals.Tags.DEL_String.Value = "Kommentar = 'test'";
		}

		
		void MySQL_Closed(System.Object sender, System.EventArgs e)
		{
			Globals.Tags.DEL_String.Value = "comment = 'test'";
		}
		

// Methods Area #####################################################################

		// establish connection to the database
		private MySqlConnection Connect2MySql ()
		{	
			string m_ConnectionsString = Globals.Tags.MySQL_DataSource.Value; 
			try 
			{	        
				conn.ConnectionString = m_ConnectionsString;
				conn.Open();
				return conn;

			}
			catch (Exception ex)
			{
				conn.Close();
				MessageBox.Show(ex.Message, "Alert");
				return null;
			}
		}
		
		
		// Read the content of the database and display it in ListBox_Tables
		private void MySQL_DB_Read()
		{
			conn = Connect2MySql ();
			try
			{		
				string Commandstring = "SELECT * FROM " + Globals.Tags.MySQL_Server_Table.Value;	
				MySqlCommand cmd = new MySqlCommand(Commandstring,conn);
				MySqlDataAdapter da = new MySqlDataAdapter(cmd);
				MySqlCommandBuilder cb = new MySqlCommandBuilder(da);

				string version = "---Unbekannt---";
				string database = "---Unbekannt---";
				string datasource = "---Unbekannt---";
				version = conn.ServerVersion;
				database = conn.Database;
				datasource = conn.DataSource;
				dt.Rows.Clear();
				dt.Columns.Clear();
				da.Fill(dt);
 		
				DataGridView1.DataSource = dt;
				DataGridView1.AutoResizeColumns();
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
			try
			{
				conn.Close();
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message);
			}	
			// The next several lines show how to get information on a specific table by name from the dataset:
			TextBox1.Text = dt.Rows.Count.ToString();
			// The column info is automatically fetched from the database, so we can read it here:
			TextBox2.Text = dt.Columns.Count.ToString();
			DataColumnCollection drc = dt.Columns;
			
			ListBox1.Items.Clear();
			int i = 0;
			foreach (DataColumn dc in drc)
			{
				// Print the column subscript, then the column's name and its data type:
				ListBox1.Items.Add(string.Format("Column name[{0}] is {1}, of type {2}",i++ , dc.ColumnName, dc.DataType));
			}			
		}
		
		
		// get the next valid ID 
		private int getNextID()
		{
			int nextID = 0;
			foreach (DataRow dr in dt.Rows)
			{
				int val = Convert.ToInt32(dr["ID"]);
				if (val > nextID)
				{
					nextID = val;
				}
			}	
			return ++nextID;
		}
		

// Buttons Area #####################################################################						

		// INSERT the actual prozess data into the MS Access database 
		void Btn_DB_Write_Click(System.Object sender, System.EventArgs e)
		{			
			// Create the dataset and add the Categories table to it:
			conn = Connect2MySql ();
			try
			{			
				
			// insert actual process data
			string Commandstring = "INSERT INTO " + Globals.Tags.MySQL_Server_Table.Value 
				+ " (ID,DateTime,Spannung,Strom,Druck,Kommentar)" + 
				String.Format("VALUES('{0}','{1}','{2}','{3}','{4}','{5}')",  
				getNextID(),
				DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"),
				Globals.Tags.Voltage.Value,
				Globals.Tags.Temperature.Value,
				Globals.Tags.Pressure.Value,
				Globals.Tags.Comment.Value
				);
				
			MySqlCommand cmd = new MySqlCommand(Commandstring, conn );
			cmd.ExecuteNonQuery();
		}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
				return;
			}
			finally
			{
				conn.Close();
			}	
			MySQL_DB_Read();
		}
		
		
		// DELETE data sets drom the database depending on the SQL command
		void Btn_Record_DEL_Click(System.Object sender, System.EventArgs e)
		{
			// Create the dataset and add the Categories table to it:
			conn = Connect2MySql ();
			try
			{
				string Commandstring = "DELETE FROM " + Globals.Tags.MySQL_Server_Table.Value
				+ " WHERE " + Globals.Tags.DEL_String.Value;
				MySqlCommand cmd = new MySqlCommand(Commandstring, conn );
				Globals.Tags.Rows_Deleted.Value = cmd.ExecuteNonQuery();
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
				return;
			}
			finally
			{
				conn.Close();
			}	
        	MySQL_DB_Read();
		}
		
		
		// write the changes to the database
		void Btn_Update_DB_Click(System.Object sender, System.EventArgs e)
		{
			conn = Connect2MySql ();
			try
			{			
				string Commandstring = "SELECT * FROM "+ Globals.Tags.MySQL_Server_Table.Value;	
				MySqlCommand cmd = new MySqlCommand(Commandstring,conn);
				MySqlDataAdapter da = new MySqlDataAdapter(cmd);
				MySqlCommandBuilder cb = new MySqlCommandBuilder(da);
			
				da.Update (dt);		
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
			try
			{
				conn.Close();
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
		}
		
		// Load a database manually
		void Btn_DB_Reload_Click(System.Object sender, System.EventArgs e)
		{
			MySQL_DB_Read();
		}
    }
}
