//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;

	using System.Collections.Generic; // for List...

	using System.Data; // needed for DataTables, DataSets...
	using System.Data.SqlClient; // needed for SQL Server	
	
	
    public partial class SQL_Server
    {
		DataTable dt = new DataTable();
		SqlConnection conn = new SqlConnection();
		
// Screen Area #####################################################################
		
		void SQL_Server_Opened(System.Object sender, System.EventArgs e)
		{
			SQLServer_DB_Read();
			Globals.Tags.Rows_Deleted.Value = 0;
		}	


// Methods Area #####################################################################

		// establish connection to the database
		private SqlConnection Connect2Sql ()
		{	
			string m_ConnectionsString = Globals.Tags.SQL_Server_DataSource.Value; 
			try 
			{	        
				conn.ConnectionString = m_ConnectionsString;
				conn.Open();
				return conn;

			}
			catch (Exception ex)
			{
				conn.Close();
				MessageBox.Show(ex.Message, "Alert");
				return null;
			}
		}
		
		
		// Read the content of the database and display it in ListBox_Tables
		private void SQLServer_DB_Read()
		{
			conn = Connect2Sql ();
			try
			{		
				string Commandstring = "SELECT * FROM " + Globals.Tags.SQL_Server_Table.Value;	
				SqlCommand cmd = new SqlCommand(Commandstring,conn);
				SqlDataAdapter da = new SqlDataAdapter(cmd);
				SqlCommandBuilder cb = new SqlCommandBuilder(da);

				string version = "---Unbekannt---";
				string database = "---Unbekannt---";
				string datasource = "---Unbekannt---";
				version = conn.ServerVersion;
				database = conn.Database;
				datasource = conn.DataSource;
				dt.Rows.Clear();
				dt.Columns.Clear();
				da.Fill(dt);
 		
				DataGridView1.DataSource = dt;
				DataGridView1.AutoResizeColumns();
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
			try
			{
				conn.Close();
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message);
			}	
			// The next several lines show how to get information on a specific table by name from the dataset:
			TextBox1.Text = dt.Rows.Count.ToString();
			// The column info is automatically fetched from the database, so we can read it here:
			TextBox2.Text = dt.Columns.Count.ToString();
			DataColumnCollection drc = dt.Columns;
			
			ListBox1.Items.Clear();
			int i = 0;
			foreach (DataColumn dc in drc)
			{
				// Print the column subscript, then the column's name and its data type:
				ListBox1.Items.Add(string.Format("Column name[{0}] is {1}, of type {2}",i++ , dc.ColumnName, dc.DataType));
			}			
		}
		
		
		// get the next valid ID 
		private int getNextID()
		{
			int nextID = 0;
			foreach (DataRow dr in dt.Rows)
			{
				int val = Convert.ToInt32(dr["ID"]);
				if (val > nextID)
				{
					nextID = val;
				}
			}	
			return ++nextID;
		}
		
		private string[] GetDatabases(string connectionstring) 
		{
			List<string> databases = new List<string>();

			SqlConnection conn = new SqlConnection(connectionstring);

			try
			{

				// sp_helpdb   storedprocedure auf Sql Server 2000 und Sql Server 2005
				SqlCommand cmd = new SqlCommand("sp_helpdb", conn);

				conn.Open();
				SqlDataReader r = cmd.ExecuteReader(CommandBehavior.CloseConnection);
				while (r.Read())
				{
					// an 1. Pos steht der dbname  
					string dbname = r[0].ToString();
					databases.Add(dbname);

				}
				r.Close();
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
				// fehlerhandling
			}
			finally
			{
				conn.Close();
			}

			return databases.ToArray();
		}
		
// Buttons Area #####################################################################						

		// INSERT the actual prozess data into the MS Access database 
		void Btn_DB_Write_Click(System.Object sender, System.EventArgs e)
		{			
			// Create the dataset and add the Categories table to it:
			conn = Connect2Sql ();
			try
			{			
				
			// insert actual process data
			string Commandstring = "INSERT INTO " + Globals.Tags.SQL_Server_Table.Value 
				+ " (ID,DB_Time,Voltage,Temperature,Pressure,Comment)" + 
				String.Format("VALUES('{0}','{1}','{2}','{3}','{4}','{5}')",  
				getNextID(),
				Globals.Tags.DateTime.Value,
				Globals.Tags.Voltage.Value,
				Globals.Tags.Temperature.Value,
				Globals.Tags.Pressure.Value,
				Globals.Tags.Comment.Value
				);
				
			SqlCommand cmd = new SqlCommand(Commandstring, conn );
			cmd.ExecuteNonQuery();
		}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
				return;
			}
			finally
			{
				conn.Close();
			}	
			SQLServer_DB_Read();
		}
		
		
		// DELETE data sets drom the database depending on the SQL command
		void Btn_Record_DEL_Click(System.Object sender, System.EventArgs e)
		{
			// Create the dataset and add the Categories table to it:
			conn = Connect2Sql ();
			try
			{
				string Commandstring = "DELETE FROM " + Globals.Tags.SQL_Server_Table.Value
				+ " WHERE " + Globals.Tags.DEL_String.Value;
				SqlCommand cmd = new SqlCommand(Commandstring, conn );
				Globals.Tags.Rows_Deleted.Value = cmd.ExecuteNonQuery();
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
				return;
			}
			finally
			{
				conn.Close();
			}	
        	SQLServer_DB_Read();
		}
		
		
		// write the changes to the database
		void Btn_Update_DB_Click(System.Object sender, System.EventArgs e)
		{
			conn = Connect2Sql ();
			try
			{			
				string Commandstring = "SELECT * FROM "+ Globals.Tags.SQL_Server_Table.Value;	
				SqlCommand cmd = new SqlCommand(Commandstring,conn);
				SqlDataAdapter da = new SqlDataAdapter(cmd);
				SqlCommandBuilder cb = new SqlCommandBuilder(da);
			
				da.Update (dt);		
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
			try
			{
				conn.Close();
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
		}
		
		
		// Load a database manually
		void Btn_DB_Reload_Click(System.Object sender, System.EventArgs e)
		{
			SQLServer_DB_Read();
		}
    }
}
