//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;
	
	using System.Data;	// needed for DataTables, DataSets...
	using System.Data.SqlServerCe;	// needed for SQLCompact Database IO


	public partial class SQL_compact
    {			
		DataTable dt = new DataTable();
		SqlCeConnection conn = new SqlCeConnection();

// Screen Area #####################################################################

		void SQL_compact_Opened(System.Object sender, System.EventArgs e)
		{
			Globals.Tags.IsTableSelected.Value = 0;
			SQLCE_DB_Read();
			Globals.Tags.Rows_Deleted.Value = 0;
		}


// Methods Area #####################################################################
		
		// establish connection to the database
		private SqlCeConnection Connect2SqlCe ()
		{
			string m_ConnectionsString = "Data Source=" + Globals.Tags.SQLCE_DataSource.Value + ";Default Lock Timeout=60000";
			try 
			{	        
				conn.ConnectionString = m_ConnectionsString;
				conn.Open();
				return conn;
			}
			catch (Exception ex)
			{
				conn.Close();
				MessageBox.Show(ex.Message, "Alert");
				return null;
			}
		}
			
		
		// Read the selected table from the database and display it in DataGridView1
		private void TableRead ()
		{	
			conn = Connect2SqlCe ();
			try
			{		
				string Commandstring = "select * FROM " + Globals.Tags.selected_table.Value;	
				SqlCeCommand cmd = new SqlCeCommand(Commandstring,conn);
				SqlCeDataAdapter da = new SqlCeDataAdapter(cmd);		
				SqlCeCommandBuilder cb = new SqlCeCommandBuilder(da);
				
				dt.Rows.Clear();
				dt.Columns.Clear();
				da.Fill (dt);
				DataGridView1.DataSource = dt;	
				DataGridView1.AutoResizeColumns();
				
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
				return;
			}
			finally
			{
				conn.Close();
			}	
			
			// The next several lines show how to get information on a specific table by name from the dataset:
			TextBox1.Text = dt.Rows.Count.ToString();
			// The column info is automatically fetched from the database, so we can read it here:
			TextBox2.Text = dt.Columns.Count.ToString();
			DataColumnCollection drc = dt.Columns;
			
			ListBox1.Items.Clear();
			int i = 0;
			foreach (DataColumn dc in drc)
			{
				// Print the column subscript, then the column's name and its data type:
				ListBox1.Items.Add(string.Format("Column name[{0}] is {1}, of type {2}",i++ , dc.ColumnName, dc.DataType));
			}	
		}
		

		// Read the content of the database and display it in ListBox_Tables
		private void SQLCE_DB_Read()
		{
			conn = Connect2SqlCe ();			
			try 
			{	        			
				string Commandstring = "select Table_Name from INFORMATION_SCHEMA.TABLES";
				SqlCeCommand cmd = new SqlCeCommand(Commandstring,conn);
				SqlCeDataReader reader = cmd.ExecuteReader();
				
				int i = 0;
				while (reader.Read())
				{
					// filter the displayed tables
					string strTable = string.Format("{0}",reader[0]);	
			//		if (!(strTable == "NEO_SYSTEMTABLE"))
			//		{
						ListBox_Tables.Items.Add(strTable);
			//		}			
					++i;
				}
			
				// Call Close when done reading.
				reader.Close();
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
			//	return null;
			}
			finally
			{
				conn.Close();
			}
		}
		
		
		// generate a "random" recipe name
		private string RandomString()
		{
			int rnd_val;
			Random random = new Random();
			rnd_val= Convert.ToInt32(Math.Floor(10000* random.NextDouble()));
			return ("RZP_" + rnd_val.ToString());
		}
		
		
		// show the data tables selection and populate it
		void ListBox_Tables_SelectionChanged(System.Object sender, System.EventArgs e)
		{
			if (ListBox_Tables.Items.Count >0)
			{
				Globals.Tags.selected_table.Value = ListBox_Tables.SelectedItem.ToString();
				Globals.Tags.IsTableSelected.Value = 1;
				TableRead();
			}
		}

		private int GetDataTableRows(string datatableName)
		{
			conn = Connect2SqlCe ();	
			String sql = "SELECT COUNT (*) FROM " + datatableName;
			SqlCeCommand cmd = new SqlCeCommand(sql, conn);	
			int count=(int) cmd.ExecuteScalar(); 
			conn.Close();
			return count;
		}

		
// Buttons Area #####################################################################										
				
		// select another SQL compact database
		void Btn_DB_Input_Click(System.Object sender, System.EventArgs e)
		{
			try 
			{	        
				OpenFileDialog dlgOpen = new OpenFileDialog();
				dlgOpen.InitialDirectory = @"C:\";
				dlgOpen.Filter = "SQL compact database (*.sdf)|*.sdf";
				dlgOpen.Title = "Choose Database";
				dlgOpen.ShowDialog();		
				if (! (dlgOpen.FileName == string.Empty) )
				{
					Globals.Tags.SQLCE_DataSource.Value = dlgOpen.FileName;			
					ListBox_Tables.Items.Clear();
					SQLCE_DB_Read();
					dt = new DataTable();
					DataGridView1.DataSource = dt;
					Globals.Tags.IsTableSelected.Value = 0;
				}
				
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message, "Alert");
			}
		}
		
		
		// write the changes to the database
		void Btn_Update_DB_Click(System.Object sender, System.EventArgs e)
		{
			conn = Connect2SqlCe ();
			try
			{			
				string Commandstring = "select * FROM " + Globals.Tags.selected_table.Value;
				SqlCeCommand cmd = new SqlCeCommand(Commandstring,conn);
				SqlCeDataAdapter da = new SqlCeDataAdapter(cmd);	
				SqlCeCommandBuilder cb = new SqlCeCommandBuilder(da);

				dt.PrimaryKey = null;
				//important if rows are changed but the row is "not left"
				foreach (DataRow dr in dt.Rows)
				{
					dr.EndEdit();
				}
				da.Update (dt);
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
				return;
			}
			finally
			{
				conn.Close();
			}
		}
		
		
		// DELETE data sets drom the database depending on the SQL command
		void Btn_Record_DEL_Click(System.Object sender, System.EventArgs e)
		{
			conn = Connect2SqlCe ();
			try
			{
				string Commandstring = "DELETE FROM " + Globals.Tags.selected_table.Value + " WHERE " + Globals.Tags.DEL_String.Value;				
				SqlCeCommand cmd = new SqlCeCommand(Commandstring, conn );
				Globals.Tags.Rows_Deleted.Value = cmd.ExecuteNonQuery();
			
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
				return;
			}
			finally
			{
				conn.Close();
			}	
			TableRead();
		}
		
		
		// INSERT the actual prozess data into the MS Access database 
		void Btn_DB_Write_Click(System.Object sender, System.EventArgs e)
		{
			conn = Connect2SqlCe ();
			try
			{
				// insert actual process data
				string Commandstring = "INSERT INTO " + Globals.Tags.selected_table.Value + " (FieldName,Voltage,Temperature,Pressure,Comment)" + 
					String.Format("VALUES('{0}','{1}','{2}','{3}','{4}')", 
					RandomString(),
					Globals.Tags.Voltage.Value,
					Globals.Tags.Temperature.Value,
					Globals.Tags.Pressure.Value,
					Globals.Tags.Comment.Value
					); 
				SqlCeCommand cmd = new SqlCeCommand(Commandstring, conn );
				cmd.ExecuteNonQuery();
			}
			catch (Exception ex)
			{
				MessageBox.Show("Error: Failed to retrieve the required data from the DataBase.\n{" 
					+ ex.Message +"}", "Attention!");
				return;
			}
			finally
			{
				conn.Close();
			}	
			TableRead();
		}
	}
}
